#include "Vector.hh"

#include <cmath> 

Vector::Vector(double nx, double ny, double nz) {
  x = nx;
  y = ny;
  z = nz;
}


double Vector::length() const {
  return sqrt(x*x+y*y+z*z);
}

std::istream& operator>>(std::istream& is, Vector& v) {
  is >> v.x >> v.y >> v.z;
  return is;
}
  
std::ostream& operator<<(std::ostream& os, Vector v) {
  os << "(" << v.x << "," << v.y << "," << v.z << ")"; 
  return os;
}
  
Vector operator+(Vector a, Vector b) {
  Vector sum(a.x + b.x,a.y + b.y, a.z + b.z);
  return sum;
}

Vector operator-(Vector a, Vector b) {
  Vector sum(a.x - b.x,a.y - b.y, a.z - b.z);
  return sum;
}
  
Vector cross(Vector a, Vector b) {
  Vector erg(a.y*b.z-a.z*b.y,
	     a.z*b.x-a.x*b.z,
	     a.x*b.y-a.y*b.x);
  return erg;
}

double dot(Vector a, Vector b) {
  return a.x*b.x+a.y*b.y+a.z*b.z;
}
