#ifndef VECTOR_HH
#define VECTOR_HH
#include <iostream>

/*
  Klasse fuer einen Punkt oder Vektor in drei Dimensionen
 */
class Vector {
public:
  Vector(double nx = 0, double xy = 0, double nz = 0);

  double length() const;

  friend std::istream& operator>>(std::istream& is, Vector& v);
  friend std::ostream& operator<<(std::ostream& os, Vector v);
  
  friend Vector operator+(Vector a, Vector b);
  friend Vector operator-(Vector a, Vector b);
  
  friend Vector cross(Vector a, Vector b);
  friend double dot(Vector a, Vector b);

private:
  double x,y,z;
};

#endif
